## fwknop 2.6.11

=== test/asan/Makefile ===

all : use-after-free.c
	cc -Wall -O1 -g -fsanitize=address -fno-omit-frame-pointer use-after-free.c

clean:
	rm -f a.out

=== test/fko-wrapper/Makefile ===

CC = gcc
LIBDIR = ../../lib/.libs
INCDIR = ../../lib
CLANG = clang

all: fko_wrapper.c fko_basic.c
	cc -Wall -g -I$(INCDIR) fko_wrapper.c -o fko_wrapper -L$(LIBDIR) -lfko
	cc -Wall -g -I$(INCDIR) fko_basic.c -o fko_basic -L$(LIBDIR) -lfko

coverage: fko_wrapper.c fko_basic.c
	$(CC) -Wall -fprofile-arcs -ftest-coverage -fno-inline -g -I$(INCDIR) fko_wrapper.c -o fko_wrapper -L$(LIBDIR) -lfko
	$(CC) -Wall -fprofile-arcs -ftest-coverage -fno-inline -g -I$(INCDIR) fko_basic.c -o fko_basic -L$(LIBDIR) -lfko

asan: fko_wrapper.c fko_basic.c
	$(CC) -Wall -fsanitize=address -fno-omit-frame-pointer -g -I$(INCDIR) fko_wrapper.c -o fko_wrapper -L$(LIBDIR) -lfko
	$(CC) -Wall -fsanitize=address -fno-omit-frame-pointer -g -I$(INCDIR) fko_basic.c -o fko_basic -L$(LIBDIR) -lfko

ubsan: fko_wrapper.c fko_basic.c
	$(CC) -Wall -fsanitize=undefined -g -I$(INCDIR) fko_wrapper.c -o fko_wrapper -L$(LIBDIR) -lfko
	$(CC) -Wall -fsanitize=undefined -fno-omit-frame-pointer -g -I$(INCDIR) fko_basic.c -o fko_basic -L$(LIBDIR) -lfko

fuzzing: fko_wrapper.c
	$(CC) -Wall -g -DFUZZING_INTERFACES -I$(INCDIR) fko_wrapper.c -o fko_wrapper -L$(LIBDIR) -lfko

asanfuzzing: fko_wrapper.c fko_basic.c
	$(CC) -Wall -fsanitize=address -fno-omit-frame-pointer -DFUZZING_INTERFACES -g -I$(INCDIR) fko_wrapper.c -o fko_wrapper -L$(LIBDIR) -lfko
	$(CC) -Wall -fsanitize=address -fno-omit-frame-pointer -DFUZZING_INTERFACES -g -I$(INCDIR) fko_basic.c -o fko_basic -L$(LIBDIR) -lfko

faultinjection: fko_fault_injection.c
	$(CC) -Wall -g -DFIU_ENABLE -I$(INCDIR) fko_fault_injection.c -o fko_fault_injection -L$(LIBDIR) -lfiu -lfko

clean:
	rm -f fko_wrapper fko_basic fko_fault_injection *gcno *gcda

=== extras/openwrt/package/fwknop/Makefile ===
include $(TOPDIR)/rules.mk

PKG_NAME:=fwknopd
PKG_VERSION:=2.0
PKG_RELEASE:=1

PKG_BUILD_DIR:=$(BUILD_DIR)/fwknop-$(PKG_VERSION)
PKG_SOURCE:=fwknop-$(PKG_VERSION).tar.gz
PKG_SOURCE_URL:=http://www.cipherdyne.org/fwknop/download
PKG_MD5SUM:=c78252216fa9627cacf61b453da915a8
PKG_CAT:=zcat
include $(INCLUDE_DIR)/package.mk

define Package/fwknopd
       SECTION:=net
       CATEGORY:=Network
       DEFAULT:=n
       TITLE:=Firewall Knock Operator Daemon
       URL:=http://www.cipherdyne.org/fwknop/
       MAINTAINER:=Jonathan Bennett <jbscience87@gmail.com>
       DEPENDS:=+libpcap +iptables
endef

define Package/fwknopd/description
       Firewall Knock Operator Daemon
       Fwknop implements an authorization scheme known as Single Packet
       Authorization (SPA) for Linux systems running iptables.  This mechanism
       requires only a single encrypted and non-replayed packet to communicate
       various pieces of information including desired access through an iptables
       policy. The main application of this program is to use iptables in a
       default-drop stance to protect services such as SSH with an additional
       layer of security in order to make the exploitation of vulnerabilities
       (both 0-day and unpatched code) much more difficult.
endef

define Package/Conffiles
       fwknopd.conf
endef

CONFIGURE_ARGS += \
       --disable-client \
       --without-gpgme \
       --with-iptables=/usr/sbin/iptables



define Package/fwknopd/install
       $(INSTALL_DIR) $(1)/usr/sbin
       $(INSTALL_DIR) $(1)/etc/fwknop
       $(INSTALL_DIR) $(1)/etc/init.d
       $(INSTALL_DIR) $(1)/usr/lib
       $(INSTALL_BIN) $(PKG_BUILD_DIR)/extras/fwknop.init.openwrt $(1)/etc/init.d/fwknopd
       $(INSTALL_BIN) $(PKG_BUILD_DIR)/server/.libs/fwknopd $(1)/usr/sbin/
       $(INSTALL_BIN) $(PKG_BUILD_DIR)/lib/.libs/libfko.so.0.0.2 $(1)/usr/lib/libfko.so.0
       $(INSTALL_BIN) $(PKG_BUILD_DIR)/lib/.libs/libfko.so.0.0.2 $(1)/usr/lib/libfko.so.0.0.2
       $(INSTALL_CONF) $(PKG_BUILD_DIR)/server/fwknopd.conf $(1)/etc/fwknop/
       $(INSTALL_CONF) $(PKG_BUILD_DIR)/server/access.conf $(1)/etc/fwknop/

endef

$(eval $(call BuildPackage,fwknopd))
#
# Copyright (C) 2006-2009 OpenWrt.org
#
# This is free software, licensed under the GNU General Public License v2.
# See /LICENSE for more information.
#

include $(TOPDIR)/rules.mk

PKG_NAME:=fwknop
PKG_VERSION:=2.0.0rc1
PKG_RELEASE:=1

PKG_SOURCE:=$(PKG_NAME)-$(PKG_VERSION).tar.gz
PKG_SOURCE_URL:=http://www.dstuart.org/fwknop/
PKG_MD5SUM:=86c41edbe78bd15e6e5e351741cb26dd

include $(INCLUDE_DIR)/package.mk

PKG_INSTALL=1

define Package/fwknop
  SECTION:=net
  CATEGORY:=Network
  DEPENDS:=+gpgme +libgdbm +libpcap +iptables
  TITLE:=Firewall KNock OPerator - fwknop
  URL:=http://www.cipherdyne.org/fwknop
endef

define Package/fwknop/description
	Fwknop implements an authorization scheme known as Single Packet
	Authorization (SPA) for Linux systems running iptables.  This mechanism
	requires only a single encrypted and non-replayed packet to communicate
	various pieces of information including desired access through an iptables
	policy. The main application of this program is to use iptables in a
	default-drop stance to protect services such as SSH with an additional
	layer of security in order to make the exploitation of vulnerabilities
	(both 0-day and unpatched code) much more difficult.
endef

TARGET_CFLAGS += $(FPIC)

define Build/Configure
	$(call Build/Configure/Default, \
		--enable-shared \
		--enable-static \
		--with-gpgme \
		--with-gpg=/usr/bin/gpg \
		--with-iptables=/usr/sbin/iptables \
		--with-sh=/bin/sh \
	)
endef

define Build/InstallDev
	$(INSTALL_DIR) $(1)/usr/include
	$(INSTALL_DATA) \
		$(PKG_INSTALL_DIR)/usr/include/fko.h \
		$(1)/usr/include/

	$(INSTALL_DIR) $(1)/usr/lib
	$(INSTALL_DATA) \
		$(PKG_INSTALL_DIR)/usr/lib/libfko.{la,a,so*} \
		$(1)/usr/lib/
endef

define Package/fwknop/install
	$(INSTALL_DIR) $(1)/usr/lib
	$(INSTALL_DATA) $(PKG_INSTALL_DIR)/usr/lib/libfko.so.* $(1)/usr/lib/
	$(INSTALL_DIR) $(1)/usr/bin
	$(INSTALL_BIN) $(PKG_INSTALL_DIR)/usr/bin/fwknop $(1)/usr/bin/
	$(INSTALL_DIR) $(1)/usr/sbin
	$(INSTALL_BIN) $(PKG_INSTALL_DIR)/usr/sbin/fwknopd $(1)/usr/sbin/
	$(INSTALL_DIR) $(1)/etc/fwknop
	$(INSTALL_CONF) $(PKG_INSTALL_DIR)/etc/fwknop/fwknopd.conf $(1)/etc/fwknop/
	$(INSTALL_CONF) $(PKG_INSTALL_DIR)/etc/fwknop/access.conf $(1)/etc/fwknop/
	$(INSTALL_DIR) $(1)/etc/init.d
	$(INSTALL_BIN) ./files/fwknopd.init $(1)/etc/init.d/fwknopd
endef

$(eval $(call BuildPackage,fwknop))

=== extras/openwrt/package/gpgme/Makefile ===
#
# Copyright (C) 2006-2009 OpenWrt.org
#
# This is free software, licensed under the GNU General Public License v2.
# See /LICENSE for more information.
#

include $(TOPDIR)/rules.mk

PKG_NAME:=gpgme
PKG_VERSION:=1.1.8
PKG_RELEASE:=1

PKG_SOURCE:=$(PKG_NAME)-$(PKG_VERSION).tar.gz
PKG_SOURCE_URL:=http://www.dstuart.org/gpgme/
PKG_MD5SUM:=c4045e6533bd78cbf952ed9597dbdd7c

include $(INCLUDE_DIR)/package.mk

PKG_INSTALL=1

define Package/gpgme
  SECTION:=libs
  CATEGORY:=Libraries
  DEPENDS:=+gnupg
  TITLE:=GPGME - GnuPG Made Easy
  URL:=http://www.gnupg.org/
endef

define Package/gpgme/description
	GnuPG Made Easy (GPGME) is a C language library that allows to add
	support for cryptography to a program.  It is designed to make access
	to public key crypto engines like GnuPG or GpgSM easier for
	applications.  GPGME provides a high-level crypto API for encryption,
	decryption, signing, signature verification and key management.
endef

TARGET_CFLAGS += $(FPIC)

define Build/Configure
	$(call Build/Configure/Default, \
		--with-gpg=/usr/bin/gpg \
		--without-gpgsm \
		--without-gpgconf \
		--enable-shared \
		--enable-static \
		--disable-rpath \
	)
endef

define Build/InstallDev
	$(INSTALL_DIR) $(2)/bin $(1)/usr/bin
	$(INSTALL_BIN) \
		$(PKG_INSTALL_DIR)/usr/bin/gpgme-config \
		$(2)/bin/
	$(SED) \
		's,^\(prefix\|exec_prefix\)=.*,\1=$(STAGING_DIR)/usr,g' \
		$(2)/bin/gpgme-config
	ln -sf $(STAGING_DIR)/host/bin/gpgme-config $(1)/usr/bin/gpgme-config

	$(INSTALL_DIR) $(1)/usr/include
	$(INSTALL_DATA) \
		$(PKG_INSTALL_DIR)/usr/include/gpgme.h \
		$(1)/usr/include/

	$(INSTALL_DIR) $(1)/usr/lib
	$(CP) \
		$(PKG_INSTALL_DIR)/usr/lib/libgpgme.{la,a,so*} \
		$(1)/usr/lib/

	$(INSTALL_DIR) $(1)/usr/share/aclocal
	$(INSTALL_DATA) \
		$(PKG_INSTALL_DIR)/usr/share/aclocal/gpgme.m4 \
		$(1)/usr/share/aclocal/
endef

define Package/gpgme/install
	$(INSTALL_DIR) $(1)/usr/lib
	$(CP) $(PKG_INSTALL_DIR)/usr/lib/libgpgme.so.* $(1)/usr/lib/
endef

$(eval $(call BuildPackage,gpgme))

=== debian/changelog ===
fwknop (2.6.11-2) unstable; urgency=medium

  * Enable NFQ in default config file (LP: #2076224)
  * Remove unnecessary libpcap0.8-dev build dep
  * Bump Standards-Version up to 4.7.0

 -- Francois Marier <francois@debian.org>  Sat, 10 Aug 2024 14:29:05 -0700

fwknop (2.6.11-1) unstable; urgency=medium

  * New upstream release
    - drop all patches merged upstream (most of them)
  * Bump copyright year in debian/copyright
  * Remove redundant dpkg-dev line in Build-Depends

 -- Francois Marier <francois@debian.org>  Fri, 03 May 2024 19:57:57 -0700

fwknop (2.6.10-20.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Upload to unstable. (Closes: #1061958)

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Fri, 01 Mar 2024 10:06:45 +1300

fwknop (2.6.10-20.1) experimental; urgency=medium

  [ Lukas Märdian ]
  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.
  * Account for additional t64 Breaks/Replaces (Closes: #1062046).

  [ Francois Marier ]
  * Add "pcap capture not compiled in" to logcheck rules.

 -- Michael Hudson-Doyle <mwhudson@debian.org>  Thu, 29 Feb 2024 04:44:10 +0000

fwknop (2.6.10-20) unstable; urgency=medium

  * Add debian/NEWS mentioning the required NFQ configuration change.
  * Add missing /etc/gai.conf to apparmor profile.

 -- Francois Marier <francois@debian.org>  Mon, 13 Nov 2023 15:42:27 -0800

fwknop (2.6.10-19) unstable; urgency=medium

  * Move apparmor profile back into fwknop-apparmor-profile.
  * Add missing apparmor-profiles-extra dependency (closes: #1055670).
  * Add Breaks/Replaces on fwknop-server for fwknop-apparmor-profile.
  * Switch to NFQ (closes: #949331).

 -- Francois Marier <francois@debian.org>  Mon, 13 Nov 2023 10:48:47 -0800

fwknop (2.6.10-18) unstable; urgency=medium

  * Add missing Replaces for fwknop-apparmor-profile.

 -- Francois Marier <francois@debian.org>  Sat, 09 Sep 2023 12:23:48 -0700

fwknop (2.6.10-17) unstable; urgency=medium

  * Add generated files to debian/clean and debian/source/options
    (closes: #1045067).
  * Move apparmor file into fwknop-server and install it in /etc/apparmor.d
    directly (as discussed in #1034055).
  * Drop obsolete lsb-base dependency.

 -- Francois Marier <francois@debian.org>  Sat, 09 Sep 2023 11:34:15 -0700

fwknop (2.6.10-16) unstable; urgency=high

  * Install apparmor profile in /usr/share/apparmor/extra-profiles/
    instead of the systemd service directory. Note that the profile
    will not be used unless manually copied into /etc/apparmor.d/
    (Closes: #1034055).

 -- Francois Marier <francois@debian.org>  Mon, 10 Apr 2023 20:52:01 -0700

fwknop (2.6.10-15) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTCBFS: (Closes: #1028394)
    + Add missing B-D: perl-xs-dev for building a perl extension.
    + Export a suitable PERL5LIB.

  [ Francois Marier ]
  * Bump Standards-Version up to 4.6.2.
  * Bump copyright year in debian/copyright.

 -- Francois Marier <francois@debian.org>  Tue, 10 Jan 2023 21:23:46 -0800

fwknop (2.6.10-14) unstable; urgency=medium

  * Remove outdated gpgme.m4 from build (closes: #1024481).
  * Remove obsolete @setcontentsaftertitlepage command from libfko.texi.
  * Update lintian overrides (new warning text).
  * libfko-perl: Drop Multi-Arch: same.
  * Drop ancient debian/NEWS file.
  * Bump Standards-Version up to 4.6.1.
  * Bump copyright year in debian/copyright.

 -- Francois Marier <francois@debian.org>  Sat, 26 Nov 2022 17:41:38 -0800

fwknop (2.6.10-13) unstable; urgency=medium

  * Fix AppArmor profile for recent versions of Debian.
  * Ship the AppArmor file in /usr/ instead of /etc/.
  * Mark patches as forwarded upstream.
  * Bump Standards-Version up to 4.6.0.

 -- Francois Marier <francois@debian.org>  Sun, 12 Sep 2021 20:09:33 -0700

fwknop (2.6.10-12) unstable; urgency=medium

  * Bump Standards-Version up to 4.5.1.
  * Bump debian/watch up to version 4.
  * Bump copyright year in debian/copyright.
  * Add upstream metadata file.

 -- Francois Marier <francois@debian.org>  Mon, 18 Jan 2021 22:55:24 -0800

fwknop (2.6.10-11) unstable; urgency=high

  * Fix gcc10 build (closes: #957244).
  * Fix typo in lintian override.
  * Build with root explicitly.

 -- Francois Marier <francois@debian.org>  Wed, 22 Jul 2020 20:33:25 -0700

fwknop (2.6.10-10) unstable; urgency=medium

  * Remove PIDFile from systemd service since systemd tries to read that
    file before fwknopd has written to it.

 -- Francois Marier <francois@debian.org>  Mon, 15 Jun 2020 20:16:27 -0700

fwknop (2.6.10-9) unstable; urgency=medium

  * Add ipset support to AppArmor profile (closes: #949332).
  * Add Ubuntu 20.04 support to AppArmor profile (LP: #1880009).
  * Bump debian-compat to 13.
    - Update location of files in *.install and *.manpages.
    - Add libfko.so symlink and libfko.la to debian/not-installed.

 -- Francois Marier <francois@debian.org>  Sun, 14 Jun 2020 18:14:42 -0700

=== debian/control ===
Source: fwknop
Section: admin
Priority: optional
Build-Depends:
 automake,
 chrpath,
 debhelper-compat (= 13),
 dh-apparmor,
 dpkg-dev (>= 1.22.5),
 iptables,
 libgdbm-dev,
 libgpgme11-dev,
 libnetfilter-queue-dev,
 libtool,
 perl-xs-dev,
 texinfo,
 wget,
Maintainer: Francois Marier <francois@debian.org>
Standards-Version: 4.7.0
Rules-Requires-Root: binary-targets
Vcs-Git: https://salsa.debian.org/debian/fwknop.git
Vcs-Browser: https://salsa.debian.org/debian/fwknop
Homepage: https://www.cipherdyne.com/fwknop/

Package: libfko3-dev
Architecture: linux-any
Multi-Arch: same
Section: libdevel
Breaks:
 libfko2-dev,
Replaces:
 libfko2-dev,
Suggests:
 libfko-doc,
Depends:
 libfko3t64 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: FireWall KNock OPerator - development library
 The FireWall KNock OPerator implements an authorization scheme called
 Single Packet Authorization (SPA), based on Netfilter and libpcap.
 .
 Its main application is to protect services such as OpenSSH with
 an additional layer of security in order to make the exploitation of
 vulnerabilities (both 0-day and unpatched code) much more difficult.
 .
 The authorization server passively listens for authorization packets via
 libpcap, so there is no service listening for network connections on the
 traditional port. Access to a protected service is only granted after a
 valid encrypted and non-replayed packet is detected.
 .
 This package provides the development library and its headers.

Package: libfko3t64
Provides: ${t64:Provides}
Section: libs
Architecture: linux-any
Multi-Arch: same
Breaks:
 libfko3 (<< ${source:Version}),
 libfko2,
Replaces:
 libfko3,
 libfko2,
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: FireWall KNock OPerator - shared library
 The FireWall KNock OPerator implements an authorization scheme called
 Single Packet Authorization (SPA), based on Netfilter and libpcap.
 .
 Its main application is to protect services such as OpenSSH with
 an additional layer of security in order to make the exploitation of
 vulnerabilities (both 0-day and unpatched code) much more difficult.
 .
 The authorization server passively listens for authorization packets via
 libpcap, so there is no service listening for network connections on the
 traditional port. Access to a protected service is only granted after a
 valid encrypted and non-replayed packet is detected.
 .
 This package provides the runtime library for fwknop (written inC).

Package: libfko-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: FireWall KNock OPerator - documentation
 The FireWall KNock OPerator implements an authorization scheme called
 Single Packet Authorization (SPA), based on Netfilter and libpcap.
 .
 Its main application is to protect services such as OpenSSH with
 an additional layer of security in order to make the exploitation of
 vulnerabilities (both 0-day and unpatched code) much more difficult.
 .
 The authorization server passively listens for authorization packets via
 libpcap, so there is no service listening for network connections on the
 traditional port. Access to a protected service is only granted after a
 valid encrypted and non-replayed packet is detected.
 .
 This package provides the library documentation.

Package: libfko-perl
Section: perl
Architecture: linux-any
Depends:
 libfko3t64 (= ${binary:Version}),
 ${misc:Depends},
 ${perl:Depends},
 ${shlibs:Depends},
Description: FireWall KNock OPerator - Perl module
 The FireWall KNock OPerator implements an authorization scheme called
 Single Packet Authorization (SPA), based on Netfilter and libpcap.
 .
 Its main application is to protect services such as OpenSSH with
 an additional layer of security in order to make the exploitation of
 vulnerabilities (both 0-day and unpatched code) much more difficult.
 .
 The authorization server passively listens for authorization packets via
 libpcap, so there is no service listening for network connections on the
 traditional port. Access to a protected service is only granted after a
 valid encrypted and non-replayed packet is detected.
 .
 This package provides the FKO module as a Perl interface.

Package: fwknop-server
Architecture: linux-any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 iptables,
 libfko3t64 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 fwknop-apparmor-profile,
Description: FireWall KNock OPerator server side - C version
 The FireWall KNock OPerator implements an authorization scheme called
 Single Packet Authorization (SPA), based on Netfilter and libpcap.
 .
 Its main application is to protect services such as OpenSSH with
 an additional layer of security in order to make the exploitation of
 vulnerabilities (both 0-day and unpatched code) much more difficult.
 .
 The authorization server passively listens for authorization packets via
 libpcap, thus preventing any connections from being processed on the
 traditional port. Access to a protected service is only granted after a
 valid encrypted and non-replayed packet is detected.

Package: fwknop-client
Architecture: linux-any
Depends:
 libfko3t64 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: FireWall KNock OPerator client side - C version
 The FireWall KNock OPerator implements an authorization scheme called
 Single Packet Authorization (SPA), based on Netfilter and libpcap.
 .
 Its main application is to protect services such as OpenSSH with
 an additional layer of security in order to make the exploitation of
 vulnerabilities (both 0-day and unpatched code) much more difficult.
 .
 This is the client program responsible for accepting password input
 from the user, constructing SPA packets that conform to the fwknop
 packet format, and encrypting packet data.

Package: fwknop-apparmor-profile
Architecture: all
Breaks:
 fwknop-server (<<2.6.10-19),
Replaces:
 fwknop-server (<<2.6.10-19),
Depends:
 apparmor-profiles-extra,
 fwknop-server (>=2.6.10-19),
 ${misc:Depends},
Description: FireWall KNock OPerator - Apparmor profile
 The FireWall KNock OPerator implements an authorization scheme called
 Single Packet Authorization (SPA), based on Netfilter and libpcap.
 .
 Its main application is to protect services such as OpenSSH with
 an additional layer of security in order to make the exploitation of
 vulnerabilities (both 0-day and unpatched code) much more difficult.
 .
 This is the apparmor profile for the FireWall KNock OPerator server.
